require'pop3'

-- change arguments for your server
obj = assert(pop3.new{host='pop3.example.com', user='joedoe', pass='secret'})

print("STAT")
print(assert(obj:stat()))
msg_num, msg_box_len = obj:stat()

print("LIST 1")
msg_id, msg_len =  obj:list(1)
print (msg_id, msg_len)
print("LIST")
lst = assert(obj:list())
print(lst)
for k,v in pairs(lst) do print(k,v) end


print('RETRIVE ALL MESSAGES FROM SERVER')
for k, msg in obj:messages() do
    print (string.format("message %5d has length %8d", k, string.len(msg)))
    -- obj:dele(k)
end

print("TOP")
msg = assert(obj:top(1, 9999))
print (string.format("message has length %8d", string.len(msg)))

print("RETRIVE SPECIFIC MESSAGE")
msg = assert(obj:retr(1))
print (string.format("message has length %8d", string.len(msg)))

print("DELETE existing message")
print(assert(obj:dele(2)))
print("DELETE nonexisting message")
print(obj:dele(msg_num + 1))

print("UIDL")
lst = assert(obj:uidl())
for k,v in pairs(lst) do print(k,v) end


print("NOOP")
print(assert(obj:noop()))
print("RSET")
print(assert(obj:rset()))
print("QUIT")
print(assert(obj:quit()))
